﻿using System.Net.Http;
using System.Threading.Tasks;
using System.Web.Mvc;
using GateWaySample.Models;
using Newtonsoft.Json;

namespace GateWaySample.Controllers
{
    public class HomeController : AsyncController
    {

        [HttpPost]
        public async Task<ActionResult> PaymentCallBack(PaymentResult result)
        {
            if (result.Status != 1) return Content("Error!");
            var httpClient = new HttpClient();

            var r = new
            {
                merchantCode = "",// مرچنت کد درگاه میهن گیت
                paymentNumber = result.PaymentNumber

            };

            var strContent = new StringContent(JsonConvert.SerializeObject(r));

            var httpVerifyResult = await httpClient.PostAsync("http://behbank.com/api/payments/verify.json", strContent);

            var verifyResult = JsonConvert.DeserializeObject<VerifyResult>((await httpVerifyResult.Content.ReadAsStringAsync()));

            return verifyResult.Status == 1 ? Content("Succeed") : Content("Error: " + verifyResult.Message);
        }

        public async Task<ActionResult> PaymentRequest()
        {
            var httpClient = new HttpClient();

            var r = new
            {
                merchantCode = "",// مرچنت کد درگاه میهن گیت
                amount = 1000,
                callBackUrl = "http://localhost:1756/Home/PaymentCallBack",
                invoiceNumber = "123",//shomare factor
                // other parameters are optional
            };

            var jsoned = JsonConvert.SerializeObject(r);

            var result = await httpClient.PostAsync("http://behbank.com/api/payments/request.json", new StringContent(jsoned));

            var str = await result.Content.ReadAsStringAsync();

            var gatewayResult = JsonConvert.DeserializeObject<GatewayResult>(str);

            if (gatewayResult.Status != 1)
            {
                return Content(gatewayResult.Message);
            }
           

            return Redirect("http://behbank.com/payment/" + gatewayResult.PaymentNumber);


        }
    }
}